/////////////////////////////////生词本/////////////////////////////////////////////////////////////////////
/* 生词本模块：
*   定义 添加生词本方法 addScb , 成功添加回调方法 onScbSuccess
*/
/////////////////////////////////生词本/////////////////////////////////////////////////////////////////////

/* 添加生词本
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "successCallback":"onScbSuccess",         //成功回调函数
 * }
 */
function addScb(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    try{ dictcn.addScb(JSON.stringify({'uwid':uwid,'successCallback':'onScbSuccess'})); }catch(e){}
}
/* 生词本添加成功
 * 参数格式json:
 * jsonData = {
 *     "uwid":"",                                 //uwid
 *     "in_scb": "1/0"
 * }
 */
function onScbSuccess(jsonData){
    jsonData = parseJson(jsonData);
    var uwid = jsonData.uwid || "";
    var in_scb = jsonData.in_scb || 0;
    $.commFun.refreshStarIconStatus(uwid,in_scb);
}

//////////////////////////// usefull functions //////////////////////////////////////////////
// 解析json
function parseJson(jsonData){
    try{if(jsonData && !isJson(jsonData)) jsonData = JSON.parse(jsonData);}catch(e){}
    return jsonData;
}
//判断是否json对象
function isJson(obj){
    var isjson = typeof(obj) == "object" && Object.prototype.toString.call(obj).toLowerCase() == "[object object]" && !obj.length;
    return isjson;
}
////////////////////////////////////////////////////////////////////////////////////////////

//////////////////////////// 学习类应用新增方法 //////////////////////////////////////////////
/* 学习类应用新增方法 模块：
*   定义
*/
//////////////////////////// 学习类应用新增方法 //////////////////////////////////////////////


/* 读写localStorage数据
 * setStorage方法参数：
 * {
 * "key": " "  //键值
 * "value":   //要保存的数据 (value 为 空字符串时，清除该条记录)
 * }
 * getStorage方法参数：
 * {
 * "key": " "  //键值 (键值为 “ parentID_* ”时，直接返回一组筛选后的数据)
 * "successCallback": ""   //回调函数名
 * }
 * getStorage方法回调函数 getPlayStatus 参数：
 * {
 * "key": "parentID_*"  //键值
 * "value": {"parentID_uwid":"","parentID_uwid":"","parentID_uwid":"","parentID_uwid":"",...}  //json数据
 * }
 */
//写入和读取 页面缓存
function setStorage(jsonData) {
    jsonData = parseJson(jsonData);
    var key = jsonData.key || "";
    var value;
    if(isJson(jsonData.value)){
        value = JSON.stringify(jsonData.value) || "";
    }
    else {
        value = jsonData.value || "";
    }
    try{ dictcn.setItem(JSON.stringify({'key':key, 'value':value})); }catch(e){}
}
function getStorage(jsonData) {
    jsonData = parseJson(jsonData);
    var key = jsonData.key || "";
    var successCallback = jsonData.successCallback || "";
    try{ dictcn.getItem(JSON.stringify({'key':key, 'successCallback':successCallback})); }catch(e){}
}
// getStorage 函数回调函数
function getPlayStatus(jsonData){
    jsonData = parseJson(jsonData);
    $.commFun.playStatusInit(jsonData);
}

/**反馈当前打开词条信息给客户端
*   参数：
*       id  //pageID
*       uwid  //当前词条uwid
*       state： “1/0”  //是否已学习
*/
function refreshStudyStatus(jsonData){
    jsonData = parseJson(jsonData);
     var id = jsonData.id || "";
     var uwid = jsonData.uwid || "";
     var state = "1";
     try{ dictcn.refreshStudyStatus(JSON.stringify({'id':id, 'uwid':uwid, 'state':state})); }catch(e){}
}

//屏幕重新唤醒时 native 调用音频 reload方法
function audioReLoad(){
    if(isPlayingAll){
        if($.audioPlayer.getProgress() == 0){
            $.commFun.isPlayingAllTest();
            $.audioPlayer.reLoad();
        }
    }
}


//打开第二级页面方法
function enterDicteePage(jsonData){
    jsonData = parseJson(jsonData);
    var pageID = jsonData.pageID || "";
    var auto_uwid = jsonData.auto_uwid || "";
    try{ dictcn.enterConversation(JSON.stringify({'pageID': pageID, 'auto_uwid':auto_uwid})); }catch(e){}
}

/**开放给native接口：更新一级页面学习记录
*   参数：
*       kcID  //单元id
*       stateList： [1,0,1,1,0,...]  //是否已听写 ，数组元素为 “数字”
*/
function flushLearnState(jsonData){
    jsonData = parseJson(jsonData);
    var kcID = jsonData.kcID || "";
    if(kcID == pageID){
        stateList = jsonData.stateList || "";
        var i = -1;
        $('.dicteebtn').each(function(){
            i++;
            var $learnState = $(this).find('.learnState');
            if($learnState.hasClass('unfinish') && stateList[i] == 1){
                $learnState.removeClass('unfinish').addClass('finish');
            }
        });
        $.commFun.progressBarChange();
    }
}

//更新 native 标题栏 文字
function refreshTitleBar(){
    var title = $('.tishi.show').attr('word');
    try{ dictcn.refreshTitleBar(JSON.stringify({'title': title})); }catch(e){}
}

//开放给native接口，创建 unload 事件
function createUnloadEvent(){
    var ev = document.createEvent('HTMLEvents');
    ev.initEvent('unload', false, true);
    window.dispatchEvent(ev); 
}

//开放给native接口，清除选择
function clearSelection(){
    var sel = window.getSelection();
    sel.removeAllRanges();
}
//开放给native接口，全选
function selectAll(){
    var sel = window.getSelection();
    sel.selectAllChildren(document.body);
}