;(function($){
    var recordani, lineAni; //录音动画标记
    $.iconAnimate = ({
        playSoundAniStart:function(icon){ //播放声音动画开始方法
            $(icon).addClass('stopSound');
            preparePlayProgress($(icon));
            icon.goon = 1;
            playProgress(icon);
        },
        playSoundAniStop:function(icon){ //播放声音动画停止方法
            $(icon).removeClass('stopSound');
            icon.goon = 0;
            endPlayProgress($(icon));
        },
        listeningAniStart:function(icon){ //听录音动画开始方法
            $(icon).addClass('lis');
            preparePlayProgress($(icon));
            icon.goon = 1;
            playProgress(icon);
        },
        listeningAniStop:function(icon){ //听录音动画停止方法
            $(icon).removeClass('lis');
            icon.goon = 0;
            endPlayProgress($(icon));
        },
        dialoAniStart:function(icon){ //听对话动画开始方法
            icon.state = 0;
            icon.ani = 1;
            dialoSoundAni(icon);
        },
        dialoAniStop:function(icon){ //听对话动画停止方法
            icon.ani = 0;
            $(icon).removeClass('state1 state2').addClass('state0');
        },
        recordAudioAniStart:function(uwid){ //录音动画开始方法
            recordAudioAniStart(uwid);
        },
        recordAudioAniStop:function(){ //录音动画停止方法
            recordAudioAniStop();
        },
        lineAinStart:function(icon){ //线条动画开始方法
            if(lineAni){
                clearTimeout(lineAni);
                lineAni = null;
            }
            pubArgu.dragStatu = false;
            $(icon).addClass('stopSound');
            lineAinPlay(icon);
        },
        lineAinStop:function(icon){ //线条动画停止方法
            $(icon).removeClass('stopSound');
            if(lineAni){
                clearTimeout(lineAni);
                lineAni = null;
            }
        },
    });
    //线条动画方法
    function lineAinPlay(icon){
        var perc = $.audioPlayer.getProgress();
        var curTime = $.audioPlayer.getCurrentTime();
        if(isNaN(perc)){
            perc = curTime / pubArgu.audioTime;
        }
        if(!pubArgu.dragStatu){
            var prop = perc;
            $('#proBar').css({'-webkit-transform': 'scaleX('+prop+')'});
            $('#proDrag').css({'-webkit-transform': 'translateX('+(prop*pubArgu.barBgWidth)+'px)'});
            playedTime.innerHTML = $.commFun.secToStandard(curTime);
        }
        if(perc < 1){
            lineAni = setTimeout(function(){
                lineAinPlay(icon);
            },1000);
        }
    }
    //音频播放进度方法
    function playProgress(icon){
        var perc = $.audioPlayer.getProgress();
        circleRotate(perc,$(icon));
        if((perc < 1) && icon.goon){
            setTimeout(function(){
                playProgress(icon);
            },100);
        }
    }
    //圆形进度条转动方法
    function circleRotate(perc,btn){
        var angle = 360*perc;
        var innerR = btn.find('.innerRight');
        var innerL = btn.find('.innerLeft');
        if(angle<180){
            innerR.css({'-webkit-transform': 'rotate('+angle+'deg)'});
        }
        else {
            innerR.css({'-webkit-transform': 'rotate(180deg)'});
            innerL.css({'-webkit-transform': 'rotate('+(angle-180)+'deg)'});
        }
    }
    //播放进度动画准备
    function preparePlayProgress(icon){
        icon.find('.innerLeft').css({'-webkit-transform': 'rotate(0deg)'});
        icon.find('.progressIcon').addClass("show");
        icon.find('.circleBorder').addClass("show");
    }
    //播放进度动画收尾
    function endPlayProgress(icon){
        icon.find('.circleBorder').removeClass("show");
        icon.find('.progressIcon').removeClass("show");
        icon.find('.innerRight').css({'-webkit-transform': 'rotate(0deg)'});
        icon.find('.innerLeft').css({'-webkit-transform': 'rotate(0deg)'});
    }
    //播放对话按钮动画
    function dialoSoundAni(btn){
        $(btn).removeClass('state'+btn.state);
        btn.state = ++btn.state>2 ? 0 : btn.state;
        $(btn).addClass('state'+btn.state);
        setTimeout(function(){
            if(btn.ani){
                dialoSoundAni(btn);
            }
        },300);
    }
    //录音动画开始方法
    function recordAudioAniStart(uwid){
        var btn = $("#"+uwid)[0];
        btn.state = 0; //标记按钮接收点击事件
        $(btn).addClass('work');
        var curr = 0;
        recordani = setInterval(function(){
            curr = (curr+1) % 5;
            recordAudioIconAnimate(curr,btn);
        }, 200);
    }
    function recordAudioIconAnimate(curr,icon){
        var last = curr-1;
        if(last<0){
            last = 4;
        }
        $(icon).removeClass('ani'+last);
        if(curr>0){
            $(icon).addClass('ani'+curr);
        }
    }
    //录音动画停止方法
    function recordAudioAniStop(){
        clearInterval(recordani);
    }
})(Zepto);