;(function($){
    var maxCount = 0; //最大计数播放过次数（当总播放次数为4时，可记录的播放过次数最大为 3）

    $.commFun = ({
        frequentPlay:function(icon){ //多次播放声音处理方法
            frequentPlay(icon);
        },
        playStatusInit:function(jsonData){ //获取播放进度状态初始化
            playStatusInit(jsonData);
        },
        progressBarChange:function(){ //一级页面进度更新
            progressBarChange();
        },
        secToStandard:function(time){ //将秒转化为标准时间格式
            return secToStandard(time);
        },
        audioProgRefresh:function(audioProg,time){ //首次载入时，根据进度记录，更新面板显示
            audioProgRefresh(audioProg,time);
        },
    });

    init(); //初始化
    function init(){
        //
    }
    //多次播放声音处理方法
    function frequentPlay(icon){
        if(pubArgu.playedCount < maxCount){
            // pubArgu.playedCount++;
            // //显示过场动画
            // var $timeAni = $('#timeAni')
            // $timeAni.find('.count').html(pubArgu.playedCount+1);
            // $timeAni.addClass('ani');
            // //继续下一次播放
            // $.audioPlayer.reLoad();
            // setTimeout(function(){
            //     $timeAni.removeClass('ani');
            //     $.audioPlayer.play();
            //     $('#countNum').children().eq(pubArgu.playedCount -1).addClass('pass');
            //     $('#playTime').children().eq(pubArgu.playedCount).addClass('pass');
            // },3300);
            // //播放完一次后，且还未能显示答案，调整为可显示答案
            // var $answerTab = $('#answerTab');
            // if (pubArgu.playedCount == 1 && $answerTab.hasClass('lock')) {
            //     $answerTab.removeClass('lock');
            //     pubArgu.swiperBody.params.touchRatio = 0.7;
            //     pubArgu.swiperBody.params.shortSwipes = true;
            //     stateList[currIndex] = 1;
            //     refreshStudyStatus({"id": parentID, "uwid": uwidList[currIndex]}); //告知客户端该章节已经听完一遍
            // }
        }
        else {
            //回退到开始位置
            pubArgu.playedCount = 0;
            $.audioPlayer.reLoad();
            $('#proBar').css({'-webkit-transform': 'scaleX(0)'});
            $('#proDrag').css({'-webkit-transform': 'translateX(0px)'});
            playedTime.innerHTML = "00:00";
        }
        //播放完一次后，且还未能显示答案，调整为可显示答案
        var $answerTab = $('#answerTab');
        if ($answerTab.hasClass('lock')) {
            $answerTab.removeClass('lock');
            pubArgu.swiperBody.params.touchRatio = 0.7;
            pubArgu.swiperBody.params.shortSwipes = true;
            stateList[currIndex] = 1;
            refreshStudyStatus({"id": parentID, "uwid": uwidList[currIndex]}); //告知客户端该章节已经听完一遍
        }
    }
    //获取播放进度状态初始化方法
    function playStatusInit(jsonData){
        var data = parseJson(jsonData.value) || {};
        //初始化 pubArgu.audiosProg 全局变量
        for(var i in data){
            if(data[i]){
                var uwid = i.split('_')[2];
                pubArgu.audiosProg[uwid] = parseJson(data[i]);
            }
        }
        //初始化更新当前页面的进度状态
        var uwid = uwidList[currIndex];
        var adp = pubArgu.audiosProg[uwid];
        if(adp){
            var audioState = audioList[uwid];
            var url = audioPrefix + audioState.aw;
            $('#playBtn').audioPlayer({"url":url, "callbackType":4, "startTime": adp.airtime});
            var time = audioState.times;
            audioProgRefresh(adp,time);
        }
    }
    //首次载入时，根据进度记录，更新面板显示
    function audioProgRefresh(audioProg,time){
        var uwid = uwidList[currIndex];
        audioProg = audioProg || pubArgu.audiosProg[uwid];
        time = time || audioList[uwid].times;
        var count = audioProg.count;
        var airtime = audioProg.airtime;
        // var $countNum = $('#countNum').children();
        // var $playTime = $('#playTime').children();
        pubArgu.playedCount = count;
        // $playTime.eq(0).addClass('pass');
        // if(count) {
            // for(var i = count-1; i>-1; i--){
                // $countNum.eq(i).addClass('pass');
                // $playTime.eq(i+1).addClass('pass');
            // }
        // }
        var prop = airtime/time;
        $('#proBar').css({'-webkit-transform': 'scaleX('+prop+')'});
        $('#proDrag').css({'-webkit-transform': 'translateX('+(prop*pubArgu.barBgWidth)+'px)'});
        playedTime.innerHTML = secToStandard(airtime);
    }



    //一级页面进度更新
    function progressBarChange(){
        var len = stateList.length, total = 0;
        for(var i=0; i<len; i++){
            if(stateList[i]){
                total++;
            }
        }
        $('#progress').css({'-webkit-transform': 'scaleX('+total/len+')'});
    }

    //将秒转化为标准时间格式
    function secToStandard(time) {
        time = Math.floor(time);
        var min = Math.floor(time/60);
        if(min > 59){
            var hour = Math.floor(min/60);
            min = min%60;
            min = min>9 ? min : "0"+min;
            min = hour+":"+min;
        }
        else {
            min = min>9 ? min : "0"+min;
        }
        var sec = time%60;
        sec = sec>9 ? sec : "0"+sec;
        return min+":"+sec;
    }
    
})(Zepto);