var pubArgu = {
	swiperPages: [],
	swiperBody: null,
	windowHeight: null,
	tabBarHeight: null,
	bottomBtnHeight: null,
	audiosProg: {}, //记录各个章节播放进度
	playedCount: 0, //当前已经播放过的次数
	audioTime: 0, //当前音频时长
	dragStatu: false, //进度条拖拽中标识符
	barBgWidth: null, //进度条宽度
}; //公用的全局变量


$(function(){
	var cutHeight, isSwipering;
	var maxIndex = uwidList.length - 1;
	pubArgu.barBgWidth = $('.proBarBg').width();
	var barBgWidth = pubArgu.barBgWidth;
	init();
	function fixPageHeight(){
		pubArgu.windowHeight = document.documentElement.clientHeight;
	    $('.swiperPages').css('height', pubArgu.windowHeight - cutHeight);
	}

	function init(){
		FastClick.attach(document.body);

		pubArgu.tabBarHeight = $('#tabBar').height();
		pubArgu.bottomBtnHeight = $('#audioPanel').height();
		cutHeight = pubArgu.tabBarHeight + pubArgu.bottomBtnHeight;
		fixPageHeight();
		
		swiperInit(); //滑动组件初始化

		bindClickEvent(); //绑定页面元素点击事件
		// pubArgu.audiosProg = {"540016672":{"count":2,"airtime":19}};
		changeDictee(currIndex); //初始化显示界面

		getStorage({"key":parentID+"_*", "successCallback":"getPlayStatus"}); //获取播放进度状态初始化

		//浏览器窗口改变时，重置swiper
		$(window).on("resize",windowSizeSwiper);

		$(window).on('unload',savePlayTimeStatus); //关闭窗口时，保存播放记录

		//捕获阶段全局阻挡多点触控
		document.addEventListener('touchstart',function(e){
			if(e.touches.length > 1) e.stopPropagation();
		},true);
	}

	//绑定页面元素点击事件
	function bindClickEvent(){
		$('#captionTab').on('click',function(e){
			e.stopPropagation();
			var $this = $(this);
			if(!$this.hasClass('active')){
				$this.addClass('active');
				$('#answerTab').removeClass('active');
				pubArgu.swiperBody.slideTo(0);
			}
		});
		$('#answerTab').on('click',function(e){
			e.stopPropagation();
			var $this = $(this);
			if($this.hasClass('lock')){
				$this.toggleClass('showTip');
				if(this.clearTime){
					clearTimeout(this.clearTime);
					this.clearTime = null;
				}
				this.clearTime = setTimeout(function(){
					$this.removeClass('showTip');
				},1200);
			}
			else {
				if(!$this.hasClass('active')){
					$this.addClass('active');
					$('#captionTab').removeClass('active');
					pubArgu.swiperBody.slideTo(1);
				}
			}
		});
		//播放声音按钮点击方法
		$('#playBtn').on('click',function(){
			if(!$.audioPlayer.ifAdpPaused()){
				savePlayTimeStatus(); //保存播放状态
			}
			else {
				$.audioPlayer.play();
			}
		});
		//goPrev 按钮点击事件
		$('#goPrev').on('click',function(){
			if(currIndex == 0) return;
			savePlayTimeStatus(); //保存播放状态
			currIndex --;
			changeDictee(currIndex); //改变页面显示
			refreshTitleBar(); //更新 native 标题栏文字
		});
		//goNext 按钮点击事件
		$('#goNext').on('click',function(){
			if(currIndex == maxIndex) return;
			savePlayTimeStatus();
			currIndex ++;
			changeDictee(currIndex);
			refreshTitleBar();
		});
		//进度条拖动事件
		var minX = $('.proBarBg').offset().left, maxX = minX+barBgWidth;
		var prec, startPrec;
		$('#proDrag').on('touchstart',function(e){
			// e.stopPropagation();
			e.preventDefault(); //阻挡默认的300ms点击事件
			pubArgu.dragStatu = true;
			startPrec = $.audioPlayer.getProgress();
			prec = startPrec;
			// info.innerHTML = "haha";
		});
		$('#proDrag').on('touchmove',function(e){
			var clientX = e.touches[0].clientX;
			if(clientX < minX){
				prec = 0;
				$(this).css({'-webkit-transform': 'translateX(0px)'});
				$('#proBar').css({'-webkit-transform': 'scaleX(0)'});
				playedTime.innerHTML = $.commFun.secToStandard(0);
			}
			else if(clientX > maxX){
				prec = 1;
				$(this).css({'-webkit-transform': 'translateX('+barBgWidth+'px)'});
				$('#proBar').css({'-webkit-transform': 'scaleX(1)'});
				playedTime.innerHTML = $.commFun.secToStandard(pubArgu.audioTime);
			}
			else {
				var offX = clientX-minX;
				prec = offX/barBgWidth;
				$(this).css({'-webkit-transform': 'translateX('+offX+'px)'});
				$('#proBar').css({'-webkit-transform': 'scaleX('+prec+')'});
				playedTime.innerHTML = $.commFun.secToStandard(pubArgu.audioTime*prec);
			}
		});
		$('#proDrag').on('touchend',function(e){
			pubArgu.dragStatu = false;
			if(prec == 1){
				//解决红米note跳转到结束位置，丢失 ended 事件的bug（手动启动ended事件内执行的函数）
				var icon = playBtn;
				$.iconAnimate.lineAinStop(icon);
                $.commFun.frequentPlay(icon);
			}
			else if(prec != startPrec){
				$.audioPlayer.setCurrentTime(prec*$.audioPlayer.getDuration());
				if($.audioPlayer.ifAdpPaused()){
					$.audioPlayer.play();
				}
			}
		});
		//进度条点击跳转进度
		$('.proBarArea').on('click',function(e){
			var pagex = e.pageX;
			var tgt = e.target;
			if(tgt == proDrag || tgt.parentNode == proDrag) return;
			if(!(pagex<minX || pagex>maxX)){
				var prec = (pagex-minX)/barBgWidth;
				if(prec != $.audioPlayer.getProgress()){
					$.audioPlayer.pause();
					$.audioPlayer.setCurrentTime(prec*$.audioPlayer.getDuration());
					$.audioPlayer.play();
				}
			}
		});
	}
	
	//滑动组件初始化
	function swiperInit(){
	    pubArgu.swiperBody = new Swiper('#swiperBody', {
	    	touchRatio : 0.1,
	    	shortSwipes : false,
	    	onSliderMove: function(){
	    		isSwipering = 1;
	    	},
	    	onSlideChangeStart: function(){
	    		isSwipering = 1;
				updateNavPosition();
			},
			onSlideChangeEnd: function(){
	    		isSwipering = 0;
			},
			onTouchEnd: function(){
				isSwipering = 0;
			},
	    });
	    $('.swiperPages').each(function(){
	    	var sp = new Swiper(this, {
		    	scrollbar: $(this).find('.swiper-scrollbar'),
		        direction: 'vertical',
		        slidesPerView: 'auto',
		        freeMode: true,
		        onInit: function(s){
		        	var slide = s.slides[0];
		        	var conHei = $(slide).children().height();
		        	if(slide.offsetHeight != conHei){
		        		$(slide).css('height', conHei);
		        		s.onResize();
		        		s.update();
		        	}
		        },
		        onTouchStart: function(s){
		        	s.setWrapperTransition(0);
		        	s.setWrapperTranslate(s.getWrapperTranslate());
		        },
		    });
		    pubArgu.swiperPages.push(sp);
	    });
	}

	//tagBar滑动切换
    function updateNavPosition(){
		$('#tabBar .active').removeClass('active');
		$('#tabBar').children().eq(pubArgu.swiperBody.activeIndex).addClass('active');
	}
    
    	
	//浏览器窗口尺寸改变时，重置swiper
	function windowSizeSwiper(){
		fixPageHeight();
		if(pubArgu.swiperBody.width){
			resizeSwiperPage();
		}
	}
	//resize swiperPages高度
	function resizeSwiperPage(goTop){
		var i, len = pubArgu.swiperPages.length;
		for(i=0; i<len; i++){
			var s = pubArgu.swiperPages[i];
            var slide = s.slides[0];
            $(slide).css("height",$(slide).find('.content').height());
			s.onResize();
			s.update(); //更新进度条
			if(goTop){
				s.setWrapperTranslate(0);
			}
		}
	}

	//有没有听过一遍，滑动和点击状态切换 pow = 1 有权限， = 0 没权限
	function swiperClickPower(pow){
		if(pow){
			//可滑动和点击
			var $answerTab = $('#answerTab');
			if($answerTab.hasClass('lock')){
				$answerTab.removeClass('lock');
				pubArgu.swiperBody.params.touchRatio = 0.7;
				pubArgu.swiperBody.params.shortSwipes = true;
			}
		}
		else {
			//不可滑动和点击
			var $answerTab = $('#answerTab');
			if(!$answerTab.hasClass('lock')){
				$answerTab.addClass('lock');
				pubArgu.swiperBody.params.touchRatio = 0.1;
				pubArgu.swiperBody.params.shortSwipes = false;
			}
		}
	}

	//切换章节时更新界面
	function changeDictee(id){
		//更新提示与答案
		$('.tishi.show').removeClass('show');
		$('.daan.show').removeClass('show');
		$('.tishi').eq(id).addClass('show');
		$('.daan').eq(id).addClass('show');
		resizeSwiperPage(1);
		//更新是否能给显示答案
		pubArgu.swiperBody.slideTo(0);
		swiperClickPower(stateList[id]);
		//更新播放面板的时间信息
		var uwid = uwidList[id];
		var audioState = audioList[uwid];
		var time = audioState.times;
		pubArgu.audioTime = time;
		totalTime.innerHTML = $.commFun.secToStandard(time);
		//音频预加载
		var url = audioPrefix + audioState.aw;
		var audioProg = pubArgu.audiosProg[uwid];
		if(audioProg){
			$('#playBtn').audioPlayer({"url":url, "callbackType":4, "startTime": audioProg.airtime});
		}
		else {
			$('#playBtn').audioPlayer({"url":url, "callbackType":4});
		}
		audioPanelRefresh(audioProg,time); //根据播放进度记录，调整界面显示
		//前进后退按钮变灰
		if(currIndex == 0){
			$('#goPrev').addClass('invalid');
		}
		else if(currIndex == maxIndex){
			$('#goNext').addClass('invalid');
		}
		else{
			$('#goPrev').removeClass('invalid');
			$('#goNext').removeClass('invalid');
		}
	}
	//根据播放进度记录，调整界面显示
	function audioPanelRefresh(audioProg,time){
		//重置状态
		// var $countNum = $('#countNum').children();
		// var $playTime = $('#playTime').children();
		// $countNum.removeClass('pass');
		// $playTime.removeClass('pass');
		//更新状态
		if(audioProg){
			var count = audioProg.count;
			var airtime = audioProg.airtime;
			pubArgu.playedCount = count;
			// $playTime.eq(0).addClass('pass');
			if(count) {
				for(var i = count-1; i>-1; i--){
					// $countNum.eq(i).addClass('pass');
					// $playTime.eq(i+1).addClass('pass');
				}
			}
			var prop = airtime/time;
			$('#proBar').css({'-webkit-transform': 'scaleX('+prop+')'});
			$('#proDrag').css({'-webkit-transform': 'translateX('+(prop*barBgWidth)+'px)'});
			playedTime.innerHTML = $.commFun.secToStandard(airtime);
		}
		else {
			//依然重置状态
			$('#proBar').css({'-webkit-transform': 'scaleX(0)'});
			$('#proDrag').css({'-webkit-transform': 'translateX(0px)'});
			playedTime.innerHTML = "00:00";
			pubArgu.playedCount = 0;
		}
	}
	
	//保存播放时间的状态
	function savePlayTimeStatus(){
		$.audioPlayer.pause(); //停止播放
		$('#playBtn').removeClass('stopSound');
		var count = pubArgu.playedCount;
		var airtime = $.audioPlayer.getCurrentTime();
		var uwid = uwidList[currIndex];
		var adp = pubArgu.audiosProg[uwid]; //利用指针修改原值
		if(adp){ //如果已经有记录
			if(adp.count != count || adp.airtime != airtime) { //且值有变化
				if(count || airtime){ //当两值并非都为零时
					adp.count = count;
					adp.airtime = airtime;
					//存入localstorage
					setStorage({"key":parentID+'_'+uwid, "value": adp});
				}
				else { //当两值都为零时
					delete pubArgu.audiosProg[uwid]; //删除对象元素，不能用指针代替
					//删除 localstorage 中的记录
					setStorage({"key":parentID+'_'+uwid, "value": ""});
				}
			}
		}
		else { //如果没有记录
			if(count || airtime){ //且两值并非都为零
				pubArgu.audiosProg[uwid] = {"count":count, "airtime":airtime};
				//存入localstorage
				setStorage({"key":parentID+'_'+uwid, "value": pubArgu.audiosProg[uwid]});
			}
		}
	}
	
});