local json_string = [=========[
{
    "_meta": {
        "dtype": "sccs_czyydcd",
        "platform": "web",
        "dsec": "sccs_czyydcd"
    },
    "_json": {
        "endtime": "1410059247",
        "exp_out_day_count": 5,
        "sn": "1407380846669",
        "starttime": "1407380847",
        "exp_in_day_count": 5,
        "uwid": 1074397186,
        "ts": "99d0",
        "json": {
            "body": [
                {}
            ],
            "dict": "sccs_czyydcd",
            "uwid": 1074397186,
            "key": "a bit",
            "prev": 1074397185,
            "next": 1074397187
        },
        "status": "0",
        "servertime": 1407380847,
        "html": null,
        "type": null,
        "key": "a bit"
    },
    "_other": {
        "resource": "file:///android_asset/themes",
        "is_in_scb": "0",
        "html": "detail_zh",
        "textSize":"10",
        "audio_path": "",
        "lesson_path":"",
        "auth": 1,
        "minify": 0,
    },
    "_userConfig": {
        "fontSize": "10",
        "tagList": ["gram","collo","img","wrong","special","reg","differ","sense","paish","phrvb"],
        "showCn": "1"
    }
}
]=========]

--[==========[
local json_string = [=========[
{
    "_meta": {
        "dtype": "sccs_czyydcd"
    },
    "_json": {
        "pron": [
            {
                "lang": "u",
                "scode": "TP"
            }
        ],
        "word": "a balanced diet",
        "def": "膳食平衡；均衡饮食",
        "uwid": 1074397185,
        "key": "a balanced diet",
        "next": 1074397186
    },
    "_other": {
        "resource": "file:///android_asset/themes",
        "html": "review_fore"
    }
}
]=========]
--]==========]

--获取表长度
function gettablen(tab)
  len = 0
  while true do
    index,value = next(tab,index)
    if index then
      len = len + 1
    else
      break
    end
  end
  return len
end

--返回table有效值
function tab(tab)
  if not tab or type(tab)~="table" then return {} end
  return tab
end

--可以循环table为空的table
function iter(t)
  return pairs(tab(t))
end
loop = iter

--转换为字符串
function tostr(str)
  if not str or type(str)~="string" or type(str)~="number" then return "" end
  str = tostring(str)
  if not str then return "" end
  return str
end

--转换为数字
function tonum(num)
  if not num or type(num)~="string" or type(num)~="number" then return 0 end
  num = tonumber(num)
  if not num then return 0 end
  return num
end

--截取两端空格
function trim (s)
  return (string.gsub(s, "^%s*(.-)%s*$", "%1"))
end

--加载文件
function rawLoadFile(path)
    local fp = io.open(path, "rb")
    local text = nil
    if fp then
        text = fp:read("*a")
        fp:close()
    end
    return text
end

--加载资源文件
function rawLoadResource(path)
    local fp = io.open(path, "rb")
    local text = nil
    if fp then
        text = fp:read("*a")
        fp:close()
    end
    return text
end

--字符串写入
function writeFile(file_name,string)
 local f = assert(io.open(file_name, 'w'))
 f:write(string)
 f:close()
end

--随机数相关函数 一般用于调试
function initrandom()
  if not _G['_is_randomseeded'] then
    math.randomseed(tostring(os.time()):reverse():sub(1, 6))
    _G['_is_randomseeded'] = true
  end
end
function getrandom(usesys, ...)
  initrandom()
  if usesys then return math.random(...) end
  if _test_ and type(_test_)=="number" and _test_>0 then
    return "?"..math.random(...)
  end
  return ""
end

--替换拼音的字符串<span style="display:inline-block">pinyin&nbsp;</span><span style="display:inline-block">pinyin&nbsp;</span>
function pinyintrim (str)

  return (str)
end

--高亮显示关键词
function hightlight(str, word)
  if not str or type(str)~="string" then return str end
  word = string.gsub(word, ".","%%%1")
  str = string.gsub(str, word, "<span class='hightlight'>%1</span>")
  return str
end

--url编码
function urldecode(s)
    s = string.gsub(s, '%%(%x%x)', function(h) return string.char(tonumber(h, 16)) end)
    return s
end

--url解码
function urlencode(s)
    s = string.gsub(s, "([^%w%.%- ])", function(c) return string.format("%%%02X", string.byte(c)) end)
    return string.gsub(s, " ", "+")
end

--URL编码
function urldecode(s)
    s = string.gsub(s, '%%(%x%x)', function(h) return string.char(tonumber(h, 16)) end)
    return s
end

function urlencode(s)
    s = string.gsub(s, "([^%w%.%- ])", function(c) return string.format("%%%02X", string.byte(c)) end)
    return string.gsub(s, " ", "+")
end

--print_r函数 用于调试
function pr(t, name, indent)
    local tableList = {}
    function table_r (t, name, indent, full)
        local id = not full and name or type(name)~="number" and tostring(name) or '['..name..']'
        local tag = indent .. id .. ' = '
        local out = {}  -- result
        if type(t) == "table" then
            if tableList[t] ~= nil then
                table.insert(out, tag .. '{} -- ' .. tableList[t] .. ' (self reference)')
            else
                tableList[t]= full and (full .. '.' .. id) or id
                if next(t) then -- Table not empty
                    table.insert(out, tag .. '{')
                    for key,value in pairs(t) do
                        table.insert(out,table_r(value,key,indent .. '|  ',tableList[t]))
                    end
                    table.insert(out,indent .. '}')
                else table.insert(out,tag .. '{}') end
            end
        else
            local val = type(t)~="number" and type(t)~="boolean" and '"'..tostring(t)..'"' or tostring(t)
            table.insert(out, tag .. val)
        end
        return table.concat(out, '\n')
    end
    return table_r(t,name or 'Value',indent or '')
end
function _print_r(t, name)
    println(pr(t,name))
end
function print_r(t, name)
    return pr(t,name)
end
function print_pre(t, name)
    return "<pre><xmp>"..pr(t,name).."</xmp></pre>"
end
-- 遍历数组  
function IsInTable(value, tbl)
for k,v in ipairs(tbl) do
   if v == value then
    return true;
   end
end
return false;
end

function getZhDsec()
    return "sccs_xsyhhycdh";
end
local template = require "template"
local json = require "json"
json_obj = json.decode(json_string)
template.caching(false)
template.use_global_include(true)

json_obj._other.resource = "."
local searchWord = "avoir"
local dsec = "wys_fycdfh"
-- local http_obj = io.popen('curl "http://capi.test.dict.cn/dtpl/yw_xfh/html/test.php?key='..urlencode(searchWord)..'&dtype='..dsec..'&fmt=json2"')
-- local http_json = http_obj:read("*all")
local http_json = [=========[
{"yaodian":{"table":{"shuzu":[["<colg>Grammaire 语法</colg>","命令式<br>未完成过去时"],["<colg>Chiffres 数字</colg>","百分数（pourcentage）"]],"style":"1"},"title":"Points-clés-要点提示"},"zhuyi":{"title":"Rappels de base-请注意","sense":[[{"def":"命令式中的宾语代词的位置见下表。其中 m’en, t’en 会出现省音现象。","table":{"style":"2","shuzu":[[{"down":"2","data":"Verbe"},{"data":"1"},{"data":"2"},{"data":"3"},{"data":"4"}],[{"data":"- le<br>- la<br>- les"},{"data":"- moi<br>- toi<br>- lui<br>- nous<br>- leur"},{"data":"- y"},{"data":"- en"}]]}}],[{"def":"注意听清楚并区分未完成过去时与动词不定式，主要是分清后缀-ais, -ait与-er的发音，-ais和-ait发音为[ε], 而-er发音为[e]。"}],[{"def":"注意听清楚并区分未完成过去时与动词不定式，主要是分清后缀-ais, -ait与-er的发音，-ais和-ait发音为[ε], 而-er发音为[e]。","example":["On va à l ’école.","on有时可能指代的是多个人，但谓语动词永远用第三人称单数。"]}],[{"def":"注意听清楚并区分未完成过去时与动词不定式，主要是分清后缀-ais, -ait与-er的发音，-ais和-ait发音为[ε], 而-er发音为[e]。","example":["On va à l ’école.","on有时可能指代的是多个人，但谓语动词永远用第三人称单数。"]},{"def":"quel引导的感叹句中，要注意quel与所修饰对象的性、数配合。","example":["Quel monde !","Quels étudiants !"]}]]},"uwid_list":["540016689","540016690","540016691","540016692","540016693","540016694","540016695"],"practicename":["Dictée 1","Dictée 2","Dictée 3","Dictée 4","Dictée 5","Dictée 6","Dictée 7"],"state_list":[0,1,0,0,1,0,0],"id":"kca01"}
]=========]
--print(http_json)
if http_json then json_obj._json.json = json.decode(http_json) end

local data = template.render("html/index.html", json_obj)
writeFile("test_local.html",data)
--print(data)
